import pyego
from pyego import Vertex, BLACK, WHITE, EMPTY

def board_demo():
    """Play Go moves on the console."""
    b = pyego.Board()
    b.play(WHITE, Vertex(0, 0))
    b.play(BLACK, Vertex(0, 1))
    b.play(WHITE, Vertex(1, 1))
    b.play(WHITE, Vertex(2, 0))

    player = BLACK
    last_move = None
    while True:
        if last_move:
            print b.to_string(last_move)
        else:
            print b.to_string()
        print "Score: %s to %s (stone balance %s)" % (
            abs(b.score()), pyego.color_name(b.winner()),
            b.approx_score())
        print "Hash: %x" % b.hash
        print "%s to play\n" % pyego.color_name(player).title()
        try:
            s = raw_input().strip()
        except EOFError:
            break
        if s == "exit":
            break
        if s == "clear":
            b.clear()
            player = BLACK
            last_move = None
            continue
        if s == "pass":
            last_move = None
        else:
            try:
                v = pyego.vertex_from_name(s)
            except ValueError:
                print "?"
                continue
            try:
                result = b.play(player, v)
            except pyego.IllegalMove, e:
                print "Illegal move: %s\n" % e
                continue
            last_move = v
        player = pyego.other_player(player)

if __name__ == "__main__":
    board_demo()
