import pyego
from pyego import BLACK, WHITE, EMPTY

START_POSITION = """\
9
. # # # O O O . O
# . # . # O . O O
. # # # # O O O #
# . # . # O . O #
. # # # # # O . #
# O O O # O . O #
# # O . O . O . #
. # # O . O O O #
# # O . O . O # .
"""

def playout_demo():
    """Demonstrate a playout from a late board position."""
    b = pyego.Board()
    b.load(START_POSITION)
    playout = pyego.Playout(b, BLACK)
    assert playout.get_last_play(BLACK) is pyego.Any
    assert playout.get_last_play(WHITE) is pyego.Any
    print b.to_string()
    passed = False
    while True:
        playout.play_one()
        move = playout.get_last_play(playout.act_player)
        if move == pyego.Pass:
            print b.to_string(),
            print "(Passed)\n"
            if passed:
                break
            passed = True
        else:
            print b.to_string(move)
            passed = False
        playout.act_player = pyego.other_player(playout.act_player)

if __name__ == "__main__":
    playout_demo()

